import type db from "@/db";
import roleTable, { type RoleInput } from "../schema/role.schema";

export default async function seed(db: db) {
  await db.insert(roleTable).values(rolesData)
}

const rolesData: RoleInput[] = [
  {
    name: "teacher",
    description: "This role represents a Teacher in Portal MEC."
  },
  {
    name: "student",
    description: "This role represents a Student in Portal MEC."
  },
  {
    name: "admin",
    description: "This role represents an MEC Admin, that can perform any action."
  },
  {
    name: "curator",
    description: "This role represents a content Curator in Portal MEC."
  },
  {
    name: "moderator",
    description: "This role represents a content Moderator in Portal MEC, with less privileges than admin."
  },
  {
    name: "supervisor",
    description: "This role represents an user Supervisor in Portal MEC."
  },
  {
    name: "editor",
    description: "This role represents a content Supervisor in Portal MEC, with less privileges than admin."
  },
  {
    name: "partner",
    description: "This role represents a partner in Portal MEC."
  },
  {
    name: "publisher",
    description: "This role represents a content publisher without supervision in Portal MEC."
  },
  {
    name: "submitter",
    description: "This role represents a content submitter in Portal MEC."
  }
]