import { collectionLikesRepo } from "@/db/repo/collection-likes.repo";
import type { CollectionModel } from "@/db/schema/collection.schema";
import type { UserModel } from "@/db/schema/user.schema";
import { Inject, Service } from "typedi";

@Service()
export class CollectionLikesService {
    @Inject()
    private readonly repo: collectionLikesRepo;

    async associateCollectionWithLikes(collectionId: CollectionModel['id'], userIds: UserModel['id'][]): Promise<void> {
        await this.repo.associateCollectionWithLikes(collectionId, userIds);
    }

    async getLikesByCollection(collectionId: CollectionModel['id']): Promise<UserModel[]> {
        return this.repo.getLikesbyCollection(collectionId);
    }

    async removeLikesFromCollection(collectionId: CollectionModel['id'], userIds: UserModel['id'][]): Promise<void> {
        await this.repo.removeLikesFromCollection(collectionId, userIds);
    }

    async isAssociationExists(collectionId: CollectionModel['id'], userId: UserModel['id']): Promise<boolean> {
        return this.repo.isAssociationExists(collectionId, userId);
    }

    async getCollectionsByUser(userId: UserModel['id']): Promise<CollectionModel[]> {
        return this.repo.getCollectionsByLike(userId);
    }

    async updateCollectionLikes(collectionId: CollectionModel['id'], userIds: UserModel['id'][]): Promise<void> {
        await this.repo.updateCollectionLikes(collectionId, userIds);
    }

}
