import { CollectionStatsRepo } from "@/db/repo/collection-stats.repo";
import type { CollectionStatsModel } from "@/db/schema/collection-stats.schema";
import { Inject, Service } from "typedi";

@Service()
export class CollectionStatsService {
  @Inject()
  private readonly repo: CollectionStatsRepo

  async create(): Promise<CollectionStatsModel> {
    return this.repo.create()
  }

  async updateViews(id: CollectionStatsModel['id']): Promise<CollectionStatsModel> {
    return this.repo.updateViews(id)
  }

  async updateDownloads(id: CollectionStatsModel['id']): Promise<CollectionStatsModel> {
    return this.repo.updateDownloads(id)
  }

  async updateLikes(id: CollectionStatsModel['id']): Promise<CollectionStatsModel> {
    return this.repo.updateLikes(id)
  }

  async updateShares(id: CollectionStatsModel['id']): Promise<CollectionStatsModel> {
    return this.repo.updateShares(id)
  }

  async updateScore(id: CollectionStatsModel['id']): Promise<CollectionStatsModel> {
    return this.repo.updateScore(id)
  }

  async updateFollows(id: CollectionStatsModel['id']): Promise<CollectionStatsModel> {
    return this.repo.updateFollows(id)
  }

  async delete(id: CollectionStatsModel['id']): Promise<CollectionStatsModel> {
    return this.repo.delete(id)
  }

  async find(
    id: CollectionStatsModel['id']
  ): Promise<CollectionStatsModel | undefined> {
    return this.repo.find(id)
  }
}