import  { ComplaintRepo } from "@/db/repo/complaint.repo";
import type { ComplaintInput, ComplaintModel, ComplaintUpdate } from "@/db/schema/complaint.schema";
import { Inject, Service } from "typedi";

@Service()
export class ComplaintService {
    @Inject()
    private readonly repo: ComplaintRepo

    async create(complaint: ComplaintInput): Promise<ComplaintModel> {
        return this.repo.create(complaint)
    }

    async update(complaint: ComplaintUpdate): Promise<ComplaintModel> {
        return this.repo.update(complaint)
    }

    async evaluate(complaint: ComplaintUpdate): Promise<ComplaintModel> {
        return this.repo.evaluate(complaint)
    }

    async delete(id: ComplaintModel['id']): Promise<ComplaintModel> {
        return this.repo.delete(id)
    }

    async find(id: ComplaintModel['id']): Promise<ComplaintModel | undefined> {
        return this.repo.find(id)
    }

    async findMany(): Promise<ComplaintModel[]> {
        return this.repo.findMany()
    }
    
}