import { ItemsRepo } from "@/db/repo/items.repo";
import type { ItemsInput, ItemsModel, ItemsUpdate } from "@/db/schema/item.schema";
import { Inject, Service } from "typedi";


@Service()
export class ItemsService {
    @Inject()
    private readonly repo: ItemsRepo

    async create(item: ItemsInput): Promise<ItemsModel> {
        return this.repo.create(item)
    }

    async update(item: ItemsUpdate): Promise<ItemsModel> {
        return this.repo.update(item)
    }

    async delete(id: ItemsModel['id']): Promise<ItemsModel> {
        return this.repo.delete(id)
    }

    async active(id: ItemsModel['id']): Promise<ItemsModel> {
        return this.repo.active(id)
    }

    async findById(id: ItemsModel['id']): Promise<ItemsModel | undefined> {
        return this.repo.findById(id)
    }

    async findMany(): Promise<ItemsModel[]> {
        return this.repo.findMany()
    }
}
