import { LanguageRepo } from "@/db/repo/language.repo";
import type { LanguageInput, LanguageModel, LanguageUpdate } from "@/db/schema/language.schema";
import { Inject, Service } from "typedi";


@Service()
export class LanguageService {
    @Inject()
    private readonly repo: LanguageRepo

    async create(language: LanguageInput): Promise<LanguageModel> {
        return this.repo.create(language)
    }

    async update(language: LanguageUpdate): Promise<LanguageModel> {
        return this.repo.update(language)
    }

    async delete(id: LanguageModel['id']): Promise<LanguageModel> {
        return this.repo.delete(id)
    }

    async find(id: LanguageModel['id']): Promise<LanguageModel | undefined> {
        return this.repo.find(id)
    }

    async findMany(): Promise<LanguageModel[]> {
        return this.repo.findMany()
    }

}