import { objectTypeRepo } from "@/db/repo/object-type.repo";
import type { ObjectTypeInput, ObjectTypeModel, ObjectTypeUpdate } from "@/db/schema/object-type.schema";
import { Inject, Service } from "typedi";


@Service()
export class ObjectTypeService {
    @Inject()
    private readonly repo: objectTypeRepo

    async create(id: ObjectTypeInput): Promise<ObjectTypeModel> {
        return this.repo.create(id)
    }

    async update(objectType: ObjectTypeUpdate): Promise<ObjectTypeModel> {
        return this.repo.update(objectType)
    }

    async delete(id: ObjectTypeModel['id']): Promise<ObjectTypeModel> {
        return this.repo.delete(id)
    }

    async findById(id: ObjectTypeModel['id']): Promise<ObjectTypeModel | undefined> {
        return this.repo.find(id)
    }

    async findMany(): Promise<ObjectTypeModel[]> {
        return this.repo.findMany()
    }

}
