import  { resourceEducationalStages } from "@/db/repo/resource-educational-stages.repo";
import type { EducationalStagesModel } from "@/db/schema/educational-stage.schema";
import type { ResourceModel } from "@/db/schema/resource.schema";
import { Inject, Service } from "typedi";

@Service()
export class ResourceEducationalStagesService {
    @Inject()
    private readonly repo: resourceEducationalStages;

    async associateResourceWithEducationalStages(resourceId: ResourceModel['id'], educationalStages: EducationalStagesModel['id'][]): Promise<void> {
        await this.repo.associateResourceWithEducationalStages(resourceId, educationalStages);
    }

    async getEducationalStagesByResource(resourceId: ResourceModel['id']): Promise<EducationalStagesModel[]> {
        return await this.repo.getEducationalStagesByResource(resourceId);
    }

    async removeEducationalStageFromResource(resourceId: ResourceModel['id'], educationalStageId: EducationalStagesModel['id']): Promise<void> {
        await this.repo.removeEducationalStageFromResource(resourceId, educationalStageId);
    }

    async isAssociationExists(resourceId: ResourceModel['id'], educationalStageId: EducationalStagesModel['id']): Promise<boolean> {
        return await this.repo.isAssociationExists(resourceId, educationalStageId);
    }

    async getResourcesByEducationalStage(educationalStageId: EducationalStagesModel['id']): Promise<ResourceModel[]> {
        return await this.repo.getResourcesByEducationalStage(educationalStageId);
    }

    async updateResourceEducationalStages(resourceId: ResourceModel['id'], newEducationalStageIds: EducationalStagesModel['id'][]): Promise<void> {
        await this.repo.updateResourceEducationalStages(resourceId, newEducationalStageIds);
    }

}