import { statsResourceRepo } from '@/db/repo/resource-stats.repo'
import type { ResourceStatsModel, ResourceStatsUpdate } from '@/db/schema/resource-stats.schema'
import { Inject, Service } from 'typedi'

@Service()
export class ResourceStatsService {
  @Inject()
  private readonly repo: statsResourceRepo

  async create(): Promise<ResourceStatsModel> {
    return this.repo.create()
  }

  async update(statsResource: ResourceStatsUpdate): Promise<ResourceStatsModel> {
    return this.repo.update(statsResource)
  }

  async viewUpdate(id: ResourceStatsModel['id']): Promise<ResourceStatsModel> {
    return this.repo.viewUpdate(id)
  }

  async downloadUpdate(id: ResourceStatsModel['id']): Promise<ResourceStatsModel> {
    return this.repo.downloadUpdate(id)
  }

  async sharesUpdate(id: ResourceStatsModel['id']): Promise<ResourceStatsModel> {
    return this.repo.sharesUpdate(id)
  }

  async delete(id: ResourceStatsModel['id']): Promise<ResourceStatsModel> {
    return this.repo.delete(id)
  }

  async findById(id: ResourceStatsModel['id']): Promise<ResourceStatsModel | undefined> {
    return this.repo.find(id)
  }

  async findMany(): Promise<ResourceStatsModel[]> {

    return this.repo.findMany()
  }
}