import  { ResourceRepo } from '@/db/repo/resource.repo'
import type { ResourceInput, ResourceModel, ResourceUpdate } from '@/db/schema/resource.schema'
import { Inject, Service } from 'typedi'

@Service()
export class ResourceService {
  @Inject()
  private readonly repo: ResourceRepo

  async create(resource: ResourceInput): Promise<ResourceModel> {
    return this.repo.create(resource)
  }

  async update(resource: ResourceUpdate): Promise<ResourceModel> {
    return this.repo.update(resource)
  }

  async deleteData(id: ResourceModel['id']): Promise<ResourceModel> {
    return this.repo.deleteData(id)
  }

  async delete(id: ResourceModel['id']): Promise<ResourceModel> {
    return this.repo.delete(id)
  }

  async active(id: ResourceModel['id']): Promise<ResourceModel> {
    return this.repo.active(id)
  }

  async findById(id: ResourceModel['id']): Promise<ResourceModel | undefined> {
    return this.repo.find(id)
  }

  async findMany(): Promise<ResourceModel[]> {

    return this.repo.findMany()
  }
}