import type db from "@/db"
import { RoleRepo } from "@/db/repo/role.repo"
import type { RoleModel, RoleInput, RoleUpdate } from "@/db/schema/role.schema"
import { Inject, Service } from "typedi"

@Service()
export class RoleService{
  @Inject()
  private readonly repo: RoleRepo

  async findMany():Promise<RoleModel[]>{
    
    return this.repo.findMany()
  }
  async findById(id: RoleModel['id']): Promise<RoleModel | null>{

    return this.repo.findById(id)
  }
  async findByName(name: RoleModel['name']): Promise<RoleModel | null>{
    
    return this.repo.findByName(name)
  }
  async create(role: RoleInput, tx?: db): Promise<RoleModel>{

    return this.repo.create(role, tx)
  }
  async update(role: RoleUpdate): Promise<RoleModel>{

    return this.repo.update(role)
  }
  async delete(id: RoleModel['id']): Promise<RoleModel>{

    return this.repo.delete(id)
  }
}