import { SubmissionRepo } from "@/db/repo/submission.repo";
import type { SubmissionInput, SubmissionModel, SubmissionUpdate } from "@/db/schema/submission.schema";
import { Inject, Service } from "typedi";

@Service()
export class SubmissionService {
    @Inject()
    private readonly repo: SubmissionRepo

    async create(submission: SubmissionInput): Promise<SubmissionInput> {
        return this.repo.create(submission)
    }

    async update(submission: SubmissionUpdate): Promise<SubmissionInput> {
        return this.repo.update(submission)
    }

    async answer(submission: SubmissionUpdate): Promise<SubmissionInput> {
        return this.repo.answer(submission)
    }

    async delete(id: SubmissionModel['id']): Promise<SubmissionInput> {
        return this.repo.delete(id)
    }

    async find(id: SubmissionModel['id']): Promise<SubmissionModel | undefined> {
        return this.repo.find(id)
    }

    async findMany(): Promise<SubmissionModel[]> {
        return this.repo.findMany()
    }
}